Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 2528)
@@ -4,8 +4,8 @@
    !! Ocean fluxes   : domain averaged freshwater budget
    !!======================================================================
-   !! History :  8.2  !  01-02  (E. Durand)  Original code
-   !!            8.5  !  02-06  (G. Madec)  F90: Free form and module
-   !!            9.0  !  06-08  (G. Madec)  Surface module
-   !!            9.2  !  09-07  (C. Talandier) emp mean s spread over erp area 
+   !! History :  OPA  ! 2001-02  (E. Durand)  Original code
+   !!   NEMO     1.0  ! 2002-06  (G. Madec)  F90: Free form and module
+   !!            3.0  ! 2006-08  (G. Madec)  Surface module
+   !!            3.2  ! 2009-07  (C. Talandier) emp mean s spread over erp area 
    !!----------------------------------------------------------------------
 
@@ -23,4 +23,5 @@
    USE lib_mpp         ! distribued memory computing library
    USE lbclnk          ! ocean lateral boundary conditions
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -31,8 +32,8 @@
    REAL(wp) ::   a_fwb_b            ! annual domain averaged freshwater budget
    REAL(wp) ::   a_fwb              ! for 2 year before (_b) and before year.
-   REAL(wp) ::   empold             ! empold to be suppressed
+   REAL(wp) ::   fwfold             ! fwfold to be suppressed
    REAL(wp) ::   area               ! global mean ocean surface (interior domain)
 
-   REAL(wp), DIMENSION(jpi,jpj) ::   e1e2_i    ! area of the interior domain (e1t*e2t*tmask_i)
+   REAL(wp), DIMENSION(jpi,jpj) ::   e1e2    ! area of the interior domain (e1t*e2t)
 
    !! * Substitutions
@@ -40,7 +41,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -65,5 +66,5 @@
       INTEGER  ::   inum                  ! temporary logical unit
       INTEGER  ::   ikty, iyear           ! 
-      REAL(wp) ::   z_emp, z_emp_nsrf, zsum_emp, zsum_erp       ! temporary scalars
+      REAL(wp) ::   z_fwf, z_fwf_nsrf, zsum_fwf, zsum_erp       ! temporary scalars
       REAL(wp) ::   zsurf_neg, zsurf_pos, zsurf_tospread
       REAL(wp), DIMENSION(jpi,jpj) ::   ztmsk_neg, ztmsk_pos, ztmsk_tospread
@@ -72,5 +73,4 @@
       !
       IF( kt == nit000 ) THEN
-         !
          IF(lwp) THEN
             WRITE(numout,*)
@@ -79,13 +79,11 @@
             IF( kn_fwb == 1 )   WRITE(numout,*) '          instantaneously set to zero'
             IF( kn_fwb == 2 )   WRITE(numout,*) '          adjusted from previous year budget'
-            IF( kn_fwb == 3 )   WRITE(numout,*) '          emp set to zero and spread out over erp area'
+            IF( kn_fwb == 3 )   WRITE(numout,*) '          fwf set to zero and spread out over erp area'
          ENDIF
          !
          IF( kn_fwb == 3 .AND. nn_sssr /= 2 )   CALL ctl_stop( 'sbc_fwb: nn_fwb = 3 requires nn_sssr = 2, we stop ' )
          !
-         e1e2_i(:,:) = e1t(:,:) * e2t(:,:) * tmask_i(:,:)
-         area = SUM( e1e2_i(:,:) )
-         IF( lk_mpp )   CALL  mpp_sum( area    )   ! sum over the global domain
-         !
+         e1e2(:,:) = e1t(:,:) * e2t(:,:) 
+         area = glob_sum( e1e2(:,:) )           ! interior global domain surface
       ENDIF
       
@@ -93,53 +91,43 @@
       SELECT CASE ( kn_fwb )
       !
-      CASE ( 0 )                               
-         WRITE(ctmp1,*)'sbc_fwb : nn_fwb = ', kn_fwb, ' is not yet associated to an option, choose either 1/2'
-         CALL ctl_stop( ctmp1 )
+      CASE ( 1 )                             !==  global mean fwf set to zero  ==!
          !
-         
-      !
-      CASE ( 1 )                               ! global mean emp set to zero
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            z_emp = SUM( e1e2_i(:,:) * emp(:,:) ) / area
-            IF( lk_mpp )   CALL  mpp_sum( z_emp    )   ! sum over the global domain
-            emp (:,:) = emp (:,:) - z_emp
-            emps(:,:) = emps(:,:) - z_emp
+            z_fwf = glob_sum( e1e2(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area   ! sum over the global domain
+            emp (:,:) = emp (:,:) - z_fwf 
+            emps(:,:) = emps(:,:) - z_fwf 
          ENDIF
          !
-      CASE ( 2 )                               ! emp budget adjusted from the previous year
-         ! initialisation
-         IF( kt == nit000 ) THEN
-            ! Read the corrective factor on precipitations (empold)
+      CASE ( 2 )                             !==  fwf budget adjusted from the previous year  ==!
+         !
+         IF( kt == nit000 ) THEN                   ! initialisation
+            !                                         ! Read the corrective factor on precipitations (fwfold)
             CALL ctl_opn( inum, 'EMPave_old.dat', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
             READ ( inum, "(24X,I8,2ES24.16)" ) iyear, a_fwb_b, a_fwb
             CLOSE( inum )
-            empold = a_fwb                  ! current year freshwater budget correction
-            !                               ! estimate from the previous year budget
+            fwfold = a_fwb                            ! current year freshwater budget correction
+            !                                         ! estimate from the previous year budget
             IF(lwp)WRITE(numout,*)
-            IF(lwp)WRITE(numout,*)'sbc_fwb : year = ',iyear  , ' freshwater budget correction = ', empold
+            IF(lwp)WRITE(numout,*)'sbc_fwb : year = ',iyear  , ' freshwater budget correction = ', fwfold
             IF(lwp)WRITE(numout,*)'          year = ',iyear-1, ' freshwater budget read       = ', a_fwb
             IF(lwp)WRITE(numout,*)'          year = ',iyear-2, ' freshwater budget read       = ', a_fwb_b
          ENDIF   
-         ! 
-         ! Update empold if new year start
+         !                                         ! Update fwfold if new year start
          ikty = 365 * 86400 / rdttra(1)    !!bug  use of 365 days leap year or 360d year !!!!!!!
          IF( MOD( kt, ikty ) == 0 ) THEN
             a_fwb_b = a_fwb
-            a_fwb   = SUM( e1e2_i(:,:) * sshn(:,:) )
-            IF( lk_mpp )   CALL  mpp_sum( a_fwb    )   ! sum over the global domain
+            a_fwb   = glob_sum( e1e2(:,:) * sshn(:,:) )   ! sum over the global domain
             a_fwb   = a_fwb * 1.e+3 / ( area * 86400. * 365. )     ! convert in Kg/m3/s = mm/s
 !!gm        !                                                      !!bug 365d year 
-            empold =  a_fwb                 ! current year freshwater budget correction
-            !                               ! estimate from the previous year budget
+            fwfold =  a_fwb                           ! current year freshwater budget correction
+            !                                         ! estimate from the previous year budget
          ENDIF
          ! 
-         ! correct the freshwater fluxes
-         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            emp (:,:) = emp (:,:) + empold
-            emps(:,:) = emps(:,:) + empold
+         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN      ! correct the freshwater fluxes
+            emp (:,:) = emp (:,:) + fwfold
+            emps(:,:) = emps(:,:) + fwfold
          ENDIF
          !
-         ! save empold value in a file
-         IF( kt == nitend .AND. lwp ) THEN
+         IF( kt == nitend .AND. lwp ) THEN         ! save fwfold value in a file
             CALL ctl_opn( inum, 'EMPave.dat', 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE., narea )
             WRITE( inum, "(24X,I8,2ES24.16)" ) nyear, a_fwb_b, a_fwb
@@ -147,71 +135,58 @@
          ENDIF
          !
-      CASE ( 3 )                               ! global emp set to zero and spread out over erp area
+      CASE ( 3 )                             !==  global fwf set to zero and spread out over erp area  ==!
          !
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            ! Select <0 and >0 area of erp
-            ztmsk_pos(:,:) = tmask_i(:,:)
-            WHERE( erp < 0.e0 ) ztmsk_pos = 0.e0
+            ztmsk_pos(:,:) = tmask_i(:,:)                      ! Select <0 and >0 area of erp
+            WHERE( erp < 0._wp )   ztmsk_pos = 0._wp
             ztmsk_neg(:,:) = tmask_i(:,:) - ztmsk_pos(:,:)
-
-            ! Area filled by <0 and >0 erp 
-            zsurf_neg = SUM( e1e2_i(:,:)*ztmsk_neg(:,:) )
-            zsurf_pos = SUM( e1e2_i(:,:)*ztmsk_pos(:,:) )
-        
-            ! emp global mean 
-            z_emp = SUM( e1e2_i(:,:) * emp(:,:) ) / area
             !
-            IF( lk_mpp )   CALL  mpp_sum( z_emp )
-            IF( lk_mpp )   CALL  mpp_sum( zsurf_neg )
-            IF( lk_mpp )   CALL  mpp_sum( zsurf_pos )
-            
-            IF( z_emp < 0.e0 ) THEN
-                ! to spread out over >0 erp area to increase evaporation damping process
-                zsurf_tospread = zsurf_pos
+            zsurf_neg = glob_sum( e1e2(:,:)*ztmsk_neg(:,:) )   ! Area filled by <0 and >0 erp 
+            zsurf_pos = glob_sum( e1e2(:,:)*ztmsk_pos(:,:) )
+            !                                                  ! fwf global mean 
+            z_fwf = glob_sum( e1e2(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area
+            !            
+            IF( z_fwf < 0._wp ) THEN         ! spread out over >0 erp area to increase evaporation
+                zsurf_tospread      = zsurf_pos
                 ztmsk_tospread(:,:) = ztmsk_pos(:,:)
-            ELSE
-                ! to spread out over <0 erp area to increase precipitation damping process
-                zsurf_tospread = zsurf_neg
+            ELSE                             ! spread out over <0 erp area to increase precipitation
+                zsurf_tospread      = zsurf_neg
                 ztmsk_tospread(:,:) = ztmsk_neg(:,:)
             ENDIF
-
-            ! emp global mean over <0 or >0 erp area
-            zsum_emp = SUM( e1e2_i(:,:) * z_emp )
-            IF( lk_mpp )   CALL  mpp_sum( zsum_emp )
-            z_emp_nsrf =  zsum_emp / ( zsurf_tospread + rsmall )
-            ! weight to respect erp field 2D structure 
-            zsum_erp = SUM( ztmsk_tospread(:,:) * erp(:,:) * e1e2_i(:,:) )
-            IF( lk_mpp )   CALL  mpp_sum( zsum_erp )
+            !
+            zsum_fwf   = glob_sum( e1e2(:,:) * z_fwf )         ! fwf global mean over <0 or >0 erp area
+!!gm :  zsum_fwf   = z_fwf * area   ???  it is right?  I think so....
+            z_fwf_nsrf =  zsum_fwf / ( zsurf_tospread + rsmall )
+            !                                                  ! weight to respect erp field 2D structure 
+            zsum_erp = glob_sum( ztmsk_tospread(:,:) * erp(:,:) * e1e2(:,:) )
             z_wgt(:,:) = ztmsk_tospread(:,:) * erp(:,:) / ( zsum_erp + rsmall )
-
-            ! final correction term to apply
-            zerp_cor(:,:) = -1. * z_emp_nsrf * zsurf_tospread * z_wgt(:,:)
-
+            !                                                  ! final correction term to apply
+            zerp_cor(:,:) = -1. * z_fwf_nsrf * zsurf_tospread * z_wgt(:,:)
+            !
+!!gm   ===>>>>  lbc_lnk should be useless as all the computation is done over the whole domain !
             CALL lbc_lnk( zerp_cor, 'T', 1. )
-
+            !
             emp (:,:) = emp (:,:) + zerp_cor(:,:)
             emps(:,:) = emps(:,:) + zerp_cor(:,:)
             erp (:,:) = erp (:,:) + zerp_cor(:,:)
-            
-            IF( nprint == 1 .AND. lwp ) THEN
-               IF( z_emp < 0.e0 ) THEN
-                  WRITE(numout,*)'       z_emp < 0'
-                  WRITE(numout,*)'       SUM(erp+)        = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2_i(:,:) )*1.e-3,' m3.s-1'
+            !
+            IF( nprint == 1 .AND. lwp ) THEN                   ! control print
+               IF( z_fwf < 0._wp ) THEN
+                  WRITE(numout,*)'   z_fwf < 0'
+                  WRITE(numout,*)'   SUM(erp+)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2(:,:) )*1.e-9,' Sv'
                ELSE
-                   WRITE(numout,*)'      z_emp >= 0'
-                   WRITE(numout,*)'      SUM(erp-)        = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2_i(:,:) )*1.e-3,' m3.s-1'
+                  WRITE(numout,*)'   z_fwf >= 0'
+                  WRITE(numout,*)'   SUM(erp-)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2(:,:) )*1.e-9,' Sv'
                ENDIF
-               WRITE(numout,*)'      SUM(empG)        = ', SUM( z_emp*e1e2_i(:,:) )*1.e-3,' m3.s-1'
-               WRITE(numout,*)'      z_emp            = ', z_emp      ,' mm.s-1'
-               WRITE(numout,*)'      z_emp_nsrf       = ', z_emp_nsrf ,' mm.s-1'
-               WRITE(numout,*)'      MIN(zerp_cor)    = ', MINVAL(zerp_cor) 
-               WRITE(numout,*)'      MAX(zerp_cor)    = ', MAXVAL(zerp_cor) 
+               WRITE(numout,*)'   SUM(empG)     = ', SUM( z_fwf*e1e2(:,:) )*1.e-9,' Sv'
+               WRITE(numout,*)'   z_fwf         = ', z_fwf      ,' Kg/m2/s'
+               WRITE(numout,*)'   z_fwf_nsrf    = ', z_fwf_nsrf ,' Kg/m2/s'
+               WRITE(numout,*)'   MIN(zerp_cor) = ', MINVAL(zerp_cor) 
+               WRITE(numout,*)'   MAX(zerp_cor) = ', MAXVAL(zerp_cor) 
             ENDIF
-            !
          ENDIF
          !
-      CASE DEFAULT    ! you should never be there
-         WRITE(ctmp1,*)'sbc_fwb : nn_fwb = ', kn_fwb, ' is not permitted for the FreshWater Budget correction, choose either 1/2'
-         CALL ctl_stop( ctmp1 )
+      CASE DEFAULT                           !==  you should never be there  ==!
+         CALL ctl_stop( 'sbc_fwb : wrong nn_fwb value for the FreshWater Budget correction, choose either 1, 2 or 3' )
          !
       END SELECT
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 2528)
@@ -30,7 +30,7 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -81,6 +81,6 @@
             CALL ctl_stop( 'sbc_ice_if: unable to allocate sf_ice structure' )   ;   RETURN
          ENDIF
-         ALLOCATE( sf_ice(1)%fnow(jpi,jpj) )
-         ALLOCATE( sf_ice(1)%fdta(jpi,jpj,2) )
+         ALLOCATE( sf_ice(1)%fnow(jpi,jpj,1) )
+         IF( sn_ice%ln_tint ) ALLOCATE( sf_ice(1)%fdta(jpi,jpj,1,2) )
 
 
@@ -107,5 +107,5 @@
                !
                zt_fzp  = fr_i(ji,jj)                        ! freezing point temperature
-               zfr_obs = sf_ice(1)%fnow(ji,jj)              ! observed ice cover
+               zfr_obs = sf_ice(1)%fnow(ji,jj,1)            ! observed ice cover
                !                                            ! ocean ice fraction (0/1) from the freezing point temperature
                IF( sst_m(ji,jj) <= zt_fzp ) THEN   ;   fr_i(ji,jj) = 1.e0
Index: trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2528)
@@ -5,8 +5,9 @@
    !!       &           covered area using LIM sea-ice model
    !! Sea-Ice model  :  LIM 3.0 Sea ice model time-stepping
-   !!======================================================================
-   !! History :  2.0   !  2006-12  (M. Vancoppenolle) Original code
-   !!            3.0   !  2008-02  (C. Talandier)  Surface module from icestp.F90
-   !!            9.0   !  2008-04  (G. Madec)  sltyle and lim_ctl routine
+   !!=====================================================================
+   !! History :  2.0  ! 2006-12  (M. Vancoppenolle) Original code
+   !!            3.0  ! 2008-02  (C. Talandier)  Surface module from icestp.F90
+   !!             -   ! 2008-04  (G. Madec)  sltyle and lim_ctl routine
+   !!            3.3  ! 2010-11  (G. Madec) ice-ocean stress always computed at each ocean time-step
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -19,11 +20,10 @@
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers
-   USE c1d             ! 1d configuration
    USE dom_oce         ! ocean space and time domain
-   USE lib_mpp
+   USE lib_mpp         ! MPP library
    USE par_ice         ! sea-ice parameters
-   USE ice
-   USE iceini
-   USE dom_ice
+   USE ice             ! LIM-3: ice variables
+   USE iceini          ! LIM-3: ice initialisation
+   USE dom_ice         ! LIM-3: ice domain
 
    USE sbc_oce         ! Surface boundary condition: ocean fields
@@ -31,5 +31,5 @@
    USE sbcblk_core     ! Surface boundary condition: CORE bulk
    USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
-   USE albedo
+   USE albedo          ! ocean & ice albedo
 
    USE phycst          ! Define parameters for the routines
@@ -47,5 +47,6 @@
    USE limvar          ! Ice variables switch
 
-   USE lbclnk
+   USE c1d             ! 1D vertical configuration
+   USE lbclnk          ! lateral boundary condition - MPP link
    USE iom             ! I/O manager library
    USE in_out_manager  ! I/O manager
@@ -57,18 +58,15 @@
    PUBLIC sbc_ice_lim  ! routine called by sbcmod.F90
    
-   CHARACTER(len=1) ::   cl_grid = 'C'     ! type of grid used in ice dynamics
-
    !! * Substitutions
 #  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM 3.0 , UCL-LOCEAN-IPSL  (2008)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE sbc_ice_lim( kt, kblk, kico )
+   SUBROUTINE sbc_ice_lim( kt, kblk )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE sbc_ice_lim  ***
@@ -92,5 +90,4 @@
       INTEGER, INTENT(in) ::   kt      ! ocean time step
       INTEGER, INTENT(in) ::   kblk    ! type of bulk (=3 CLIO, =4 CORE)
-      INTEGER, INTENT(in) ::   kico    ! ice-ocean stress treatment
       !!
       INTEGER  ::   jl                 ! loop index
@@ -143,5 +140,5 @@
                &                      qla_ice   , dqns_ice  , dqla_ice  ,               &
                &                      tprecip   , sprecip   ,                           &
-               &                      fr1_i0    , fr2_i0    , cl_grid, jpl  )
+               &                      fr1_i0    , fr2_i0    , cp_ice_msh, jpl  )
             !         
          CASE( 4 )                                       ! CORE bulk formulation
@@ -150,5 +147,5 @@
                &                      qla_ice   , dqns_ice  , dqla_ice  ,               &
                &                      tprecip   , sprecip   ,                           &
-               &                      fr1_i0    , fr2_i0    , cl_grid, jpl  )
+               &                      fr1_i0    , fr2_i0    , cp_ice_msh, jpl  )
          END SELECT
 
@@ -161,34 +158,34 @@
          !                                           ! Store previous ice values
 !!gm : remark   old_...   should becomes ...b  as tn versus tb  
-         old_a_i(:,:,:)   = a_i(:,:,:)     ! ice area
-         old_e_i(:,:,:,:) = e_i(:,:,:,:)   ! ice thermal energy
-         old_v_i(:,:,:)   = v_i(:,:,:)     ! ice volume
-         old_v_s(:,:,:)   = v_s(:,:,:)     ! snow volume 
-         old_e_s(:,:,:,:) = e_s(:,:,:,:)   ! snow thermal energy
-         old_smv_i(:,:,:) = smv_i(:,:,:)   ! salt content
-         old_oa_i(:,:,:)  = oa_i(:,:,:)    ! areal age content
+         old_a_i  (:,:,:)   = a_i  (:,:,:)     ! ice area
+         old_e_i  (:,:,:,:) = e_i  (:,:,:,:)   ! ice thermal energy
+         old_v_i  (:,:,:)   = v_i  (:,:,:)     ! ice volume
+         old_v_s  (:,:,:)   = v_s  (:,:,:)     ! snow volume 
+         old_e_s  (:,:,:,:) = e_s  (:,:,:,:)   ! snow thermal energy
+         old_smv_i(:,:,:)   = smv_i(:,:,:)     ! salt content
+         old_oa_i (:,:,:)   = oa_i (:,:,:)     ! areal age content
 
          !                                           ! intialisation to zero    !!gm is it truly necessary ???
-         d_a_i_thd(:,:,:)   = 0.e0 ; d_a_i_trp(:,:,:)   = 0.e0
-         d_v_i_thd(:,:,:)   = 0.e0 ; d_v_i_trp(:,:,:)   = 0.e0
-         d_e_i_thd(:,:,:,:) = 0.e0 ; d_e_i_trp(:,:,:,:) = 0.e0
-         d_v_s_thd(:,:,:)   = 0.e0 ; d_v_s_trp(:,:,:)   = 0.e0
-         d_e_s_thd(:,:,:,:) = 0.e0 ; d_e_s_trp(:,:,:,:) = 0.e0
-         d_smv_i_thd(:,:,:) = 0.e0 ; d_smv_i_trp(:,:,:) = 0.e0
-         d_oa_i_thd(:,:,:)  = 0.e0 ; d_oa_i_trp(:,:,:)  = 0.e0
-         !
-         fseqv(:,:)     = 0.e0
-         fsbri(:,:)     = 0.e0     ; fsalt_res(:,:) = 0.e0
+         d_a_i_thd  (:,:,:)   = 0.e0   ;   d_a_i_trp  (:,:,:)   = 0.e0
+         d_v_i_thd  (:,:,:)   = 0.e0   ;   d_v_i_trp  (:,:,:)   = 0.e0
+         d_e_i_thd  (:,:,:,:) = 0.e0   ;   d_e_i_trp  (:,:,:,:) = 0.e0
+         d_v_s_thd  (:,:,:)   = 0.e0   ;   d_v_s_trp  (:,:,:)   = 0.e0
+         d_e_s_thd  (:,:,:,:) = 0.e0   ;   d_e_s_trp  (:,:,:,:) = 0.e0
+         d_smv_i_thd(:,:,:)   = 0.e0   ;   d_smv_i_trp(:,:,:)   = 0.e0
+         d_oa_i_thd (:,:,:)   = 0.e0   ;   d_oa_i_trp (:,:,:)   = 0.e0
+         !
+         fseqv    (:,:) = 0.e0
+         fsbri    (:,:) = 0.e0     ;   fsalt_res(:,:) = 0.e0
          fsalt_rpo(:,:) = 0.e0
-         fhmec(:,:)     = 0.e0     ; fhbri(:,:)     = 0.e0
-         fmmec(:,:)     = 0.e0     ; fheat_res(:,:) = 0.e0
-         fheat_rpo(:,:) = 0.e0     ; focea2D(:,:)   = 0.e0
-         fsup2D(:,:)    = 0.e0
+         fhmec    (:,:) = 0.e0     ;   fhbri    (:,:) = 0.e0
+         fmmec    (:,:) = 0.e0     ;   fheat_res(:,:) = 0.e0
+         fheat_rpo(:,:) = 0.e0     ;   focea2D  (:,:) = 0.e0
+         fsup2D   (:,:) = 0.e0
          ! 
-         diag_sni_gr(:,:) = 0.e0   ; diag_lat_gr(:,:) = 0.e0
-         diag_bot_gr(:,:) = 0.e0   ; diag_dyn_gr(:,:) = 0.e0
-         diag_bot_me(:,:) = 0.e0   ; diag_sur_me(:,:) = 0.e0
+         diag_sni_gr(:,:) = 0.e0   ;   diag_lat_gr(:,:) = 0.e0
+         diag_bot_gr(:,:) = 0.e0   ;   diag_dyn_gr(:,:) = 0.e0
+         diag_bot_me(:,:) = 0.e0   ;   diag_sur_me(:,:) = 0.e0
          ! dynamical invariants
-         delta_i(:,:) = 0.e0       ; divu_i (:,:) = 0.e0       ;    shear_i(:,:) = 0.e0
+         delta_i(:,:) = 0.e0       ;   divu_i(:,:) = 0.e0       ;   shear_i(:,:) = 0.e0
 
                           CALL lim_rst_opn( kt )     ! Open Ice restart file
@@ -196,5 +193,6 @@
          IF( ln_nicep )   CALL lim_prt_state( jiindx, jjindx, 1, ' - Beginning the time step - ' )   ! control print
          !
-         IF( .NOT. lk_c1d ) THEN                     ! Ice dynamics & transport (not in 1D case)
+         IF( .NOT. lk_c1d ) THEN
+                                                     ! Ice dynamics & transport (not in 1D case)
                           CALL lim_dyn( kt )              ! Ice dynamics    ( rheology/dynamics )
                           CALL lim_trp( kt )              ! Ice transport   ( Advection/diffusion )
@@ -204,5 +202,4 @@
                           CALL lim_itd_me                 ! Mechanical redistribution ! (ridging/rafting)
          ENDIF
-         !
          !                                           ! Ice thermodynamics 
                           CALL lim_var_glo2eqv            ! equivalent variables
@@ -216,5 +213,5 @@
                           CALL lim_itd_th( kt )           !  Remap ice categories, lateral accretion  !
          !
-         !                                           ! Global variables update |
+         !                                           ! Global variables update
                           CALL lim_var_agg( 1 )           ! requested by limupdate
                           CALL lim_update                 ! Global variables update
@@ -223,8 +220,5 @@
          IF( ln_nicep )   CALL lim_prt_state( jiindx, jjindx, 2, ' - Final state - ' )   ! control print
          !
-         !                                           ! Fluxes of mass and heat to the ocean |
-                         CALL lim_sbc_flx( kt )           ! Ice/Ocean heat freshwater/salt fluxes
-         IF( ln_limdyn .AND. kico == 0 )   &              ! Ice/Ocean stresses (only in ice-dynamic case)
-            &            CALL lim_sbc_tau( kt, kico )     ! otherwise the atm.-ocean stresses are used everywhere
+                          CALL lim_sbc_flx( kt )     ! Update surface ocean mass, heat and salt fluxes
          !
          IF( ln_nicep )   CALL lim_prt_state( jiindx, jjindx, 3, ' - Final state lim_sbc - ' )   ! control print
@@ -239,12 +233,15 @@
          IF( ln_nicep )   CALL lim_ctl               ! alerts in case of model crash
          !
-      ENDIF                                          ! End sea-ice time step only
-
-      !                                              !--------------------------!
-      ! Ice/Ocean stresses (nn_ico_cpl=1 or 2 cases) !  at all ocean time step  !
-      !                                              !--------------------------!
-      IF( ln_limdyn .AND. kico /= 0 )   &
-         &                CALL lim_sbc_tau( kt, kico ) 
-!!gm   remark, in this case the ocean-ice stress is not saved in diag call above .....  find a solution!!!
+      ENDIF                                    ! End sea-ice time step only
+
+      !                                        !--------------------------!
+      !                                        !  at all ocean time step  !
+      !                                        !--------------------------!
+      !                                               
+      !                                              ! Update surface ocean stresses (only in ice-dynamic case)
+      !                                                   ! otherwise the atm.-ocean stresses are used everywhere
+      IF( ln_limdyn )     CALL lim_sbc_tau( kt, ub(:,:,1), vb(:,:,1) )  ! using before instantaneous surf. currents
+      
+!!gm   remark, the ocean-ice stress is not saved in ice diag call above .....  find a solution!!!
       !
    END SUBROUTINE sbc_ice_lim
@@ -664,6 +661,6 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE sbc_ice_lim ( kt, kblk, kico )     ! Dummy routine
-      WRITE(*,*) 'sbc_ice_lim: You should not have seen this print! error?', kt, kblk, kico
+   SUBROUTINE sbc_ice_lim ( kt, kblk )     ! Dummy routine
+      WRITE(*,*) 'sbc_ice_lim: You should not have seen this print! error?', kt, kblk
    END SUBROUTINE sbc_ice_lim
 #endif
